// score:100
// O(n * 3^n + c)
// pure DP
#include <bits/stdc++.h>
using namespace std;
constexpr int mod = 1000000007;
void xadd(int &a, int b){
    if((a+=b)>=mod) a-=mod;
}
int mul(int const&a, int const&b){
    return a*(long long)b%mod;
}

int inv_rec_2(int const&a){
    assert(a!=0);
    if(a==1) return 1;
    int ret = mod-mul((mod/a), inv_rec_2(mod%a));
    return ret;
}

vector<int> fa, ifa;

void gen_fa(int lim){
    fa.resize(lim, 1);
    ifa.resize(lim, 1);
    for(int i=1;i<lim;++i){
        fa[i] = mul(fa[i-1], i);
        ifa[i] = inv_rec_2(fa[i]);
    }
}

int binom(int n, int k){
    if(n<0) return 0;
    if(k<0) return 0;
    if(n-k<k) return binom(n, n-k);
    return mul(mul(fa[n], ifa[k]), ifa[n-k]);
}

signed main(){
    int n, m, c, a, b;
    cin >> n >> m >> c;
    gen_fa(n+c+2);
    vector<bitset<16>> g(n, 0);
    for(int i=0;i<n;++i) g[i][i] = 1;
    while(m--){
        cin >> a >> b;
        g[a][b] = g[b][a] = 1;
    }
    vector<char> is_sp(1<<n);
    for(int m=0;m<(1<<n);++m){
        bitset<16> bi(0);
        bool f = false;
        for(int i=0;i<n;++i)
            if((m>>i)&1){
                if((bi&g[i]).any()) f=true;
                bi|=g[i];
            }
        is_sp[m] = !f;
    }
    vector<vector<int> > dp(n+2, vector<int>(1<<n, 0));
    dp[0][(1<<n)-1] = 1;
    int ans = 0;
    for(int i=0;i<=n;++i){
        for(int m=0;m<(1<<n);++m){
            if(dp[i][m]){
                for(int l=m;l;l=(l-1)&m){
                    if(is_sp[l]){
                        xadd(dp[i+1][m^l], dp[i][m]);
                    }
                }
            }
        }
        xadd(ans, binom(c, i+1)*(long long)dp[i+1][0]%mod);
    }
    cout << ans << "\n";
}
